//+------------------------------------------------------------------+
//|                                             Period Seperator.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window

extern ENUM_TIMEFRAMES timeFrame = PERIOD_CURRENT;
extern color   LineColor = DarkOliveGreen; 
extern int     LineStyle = STYLE_DOT;
extern int     LineWidth = 1;
extern string  LinesID   = "PeriodSeparator";
extern bool    ObjOnBckgrnd = true;
extern int     BarsLimit = 0;

double dummyBuffer[];
string indicatorFileName;
int init()
{
   IndicatorBuffers(1);
   SetIndexBuffer(0,dummyBuffer);
      indicatorFileName = WindowExpertName();
      timeFrame  = MathMax(timeFrame,_Period);
   return(0);
}
   
int deinit()
{
   int lookForLength = StringLen(LinesID);
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == LinesID) ObjectDelete(name);
      }
   return(0); 
}

//
//
//
//
//
   
int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;
   
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (BarsLimit>0) limit = MathMin(limit,BarsLimit);
           
           

      if (timeFrame!=_Period) { double dummy = iCustom(NULL,timeFrame,indicatorFileName,PERIOD_CURRENT,LineColor,LineStyle,LineWidth,LinesID,ObjOnBckgrnd,0,0); return(0); }
      
      for(i=limit;i>=0;i--)
      {      
      
         string name = LinesID+":"+Time[i];
         ObjectDelete(name);
         ObjectCreate(name,OBJ_VLINE,0,Time[i],High[i]);
            ObjectSet(name,OBJPROP_COLOR,LineColor); // Color value to set/get object color.
            ObjectSet(name,OBJPROP_STYLE,LineStyle); // Value is one of STYLE_SOLID, STYLE_DASH, STYLE_DOT, STYLE_DASHDOT, STYLE_DASHDOTDOT constants to set/get object line style.
            ObjectSet(name,OBJPROP_WIDTH,LineWidth); // Integer value to set/get object line width. Can be from 1 to 5.
            ObjectSet(name,OBJPROP_BACK,ObjOnBckgrnd); // Boolean value to set/get background drawing flag for object. (for example "true" will hide the value at the bottom of the chart.)

      }
   return(0);
}